.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include rASpack.inc
include unpaspack_1.0.inc
include Res_rebuild_engee.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke LoadIcon,hInstance,500 
	    mov hIcon,eax 
	    push hWin
	    pop hWnd_main
    	invoke SendMessage,hWin,WM_SETICON,NULL,hIcon
    	invoke ShowMess,addr Ready_msg 
	.elseif eax==WM_COMMAND
		mov eax,wParam
		.if lParam!=0	
			mov edx,wParam
			shr edx,16
			.if dx==BN_CLICKED
				.if ax==IDC_BTN1
					
					invoke OpenDialog, hWin
					call LoadFile
				.elseif ax==IDC_BTN2
					invoke Save_file,hWin
					invoke MessageBox,0,addr sss2,addr sss2,MB_OK	
				.endif
			.endif
		.else
			.if ax==IDM_About
				INVOKE DialogBoxParam, hInstance, IDD_About, hWin, ADDR AboutProc, 0
			.endif	
		.endif
					
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

AboutProc PROC hWin: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM
LOCAL  pMusic:LPVOID
LOCAL nMusicSize:DWORD
  	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		;******** Load the music*****************************
		push esi
		INVOKE FindResource, hInstance, IDM_MUSIC, RT_RCDATA
		push eax
		INVOKE SizeofResource, hInstance, eax
		mov nMusicSize, eax
		pop eax
		INVOKE LoadResource, hInstance, eax
		INVOKE LockResource, eax
		mov esi, eax
		mov eax, nMusicSize
		add eax, SIZEOF nMusicSize
		INVOKE GlobalAlloc, GPTR, eax
		mov pMusic, eax
		mov ecx, nMusicSize
		mov dword ptr [eax], ecx
		add eax, SIZEOF nMusicSize
		mov edi, eax
		rep movsb
		pop esi
;		INVOKE mfmPlay, pMusic
		INVOKE SetDlgItemText, hWin, IDC_INFO, ADDR sInfo
		INVOKE SetDlgItemText, hWin, IDC_Staff, ADDR sStaff
		INVOKE SetDlgItemText, hWin, IDC_Thanks, ADDR sThanks
		INVOKE SetDlgItemText, hWin,IDC_Copyright,addr sCopyright

	.elseif uMsg == WM_CREATE
		
	.elseif eax==WM_COMMAND
	mov eax,wParam
	.elseif eax==WM_CLOSE
		INVOKE mfmPlay, 0
		INVOKE GlobalFree, pMusic
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

AboutProc ENDP

;######### [ SEH PROCEDURES & MACROS] ##################################################
LoadSEH     MACRO

	push fs:[0]
	pop seh.PrevLink
	mov seh.CurrentHandler,offset SEHHandler
	mov seh.SafeOffset,offset FinalExit
	lea eax,seh
	mov fs:[0], eax
	mov seh.PrevEsp,esp
	mov seh.PrevEbp,ebp
ENDM        LoadSEH

SEHHandler proc C uses edx pExcept:DWORD,pFrame:DWORD,pContext:DWORD,pDispatch:DWORD
	mov edx,pFrame		
	assume edx:ptr SEH
	mov eax,pContext
	;----------
	pushad
	mov eax,pExcept
	mov eax,pFrame 
	mov eax,pContext
	mov eax,pDispatch
	popad
	;-----------
	assume eax:ptr CONTEXT
	push [edx].SafeOffset
	pop [eax].regEip
	push [edx].PrevEsp
	pop [eax].regEsp
	push [edx].PrevEbp
	pop [eax].regEbp
	mov ValidPE, FALSE
	invoke  ShowMess,addr Pecheck_err_msg	
	mov eax,ExceptionContinueExecution
	ret
SEHHandler endp

ExitSEH     MACRO
    pop     fs:[0]
    add     esp, 12
ENDM        ExitSEH
;#######################################################################################

OpenDialog proc hWnd:HWND
	invoke RtlZeroMemory,addr buffer,9
	mov ofn.lStructSize,SIZEOF ofn
	push hWnd
	pop  ofn.hWndOwner
	push hInstance
	pop  ofn.hInstance
	mov  ofn.lpstrFilter, OFFSET FilterString
	mov  ofn.lpstrFile, OFFSET buffer
	mov  ofn.nMaxFile,MAXSIZE
	mov  ofn.Flags, OFN_FILEMUSTEXIST or \
                        OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
                        OFN_EXPLORER or OFN_HIDEREADONLY
	mov  ofn.lpstrTitle, OFFSET OurTitle
	invoke GetOpenFileName, ADDR ofn	
 
	ret

OpenDialog  endp

LoadFile proc 

		invoke CreateFile,ADDR buffer,GENERIC_READ+GENERIC_WRITE ,0,NULL,\
						  OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
		.if eax !=INVALID_HANDLE_VALUE
			mov hFile,eax
			invoke ShowMess,addr FileOpen_ok_msg  
			invoke	GetFileSize, hFile, 00h
			mov	f_size,eax
			invoke GlobalAlloc, GMEM_FIXED, f_size	; Allocate memory
			.if eax!=0
				invoke ShowMess,addr mem_ok_msg
				mov pFile,eax
				invoke	ReadFile, hFile, pFile, f_size, offset read_len, NULL
					.if eax!=0
						call PE_Check
						.if ValidPE !=FALSE
							invoke Unpack_app, eax,ebx
							mov FileOpenOk,TRUE						
						.else														
							mov FileOpenOk,FALSE							
							invoke	GlobalFree, pFile						 
						.endif
					.else
						mov FileOpenOk,FALSE
						invoke	GlobalFree, pFile
						invoke ShowMess,addr read_err
					.endif		
			.else
				mov FileOpenOk,FALSE
				invoke ShowMess,addr mem_err_msg
			.endif
		.else
			mov FileOpenOk,FALSE
			invoke ShowMess,addr FileOpen_err_msg
		.endif
ret

LoadFile endp

Get_HAsh proc uses ebx esi ecx
	xor eax,eax
	xor ebx,ebx
	mov esi,AspLoader
	mov ecx,0c8h
ll:
	LODSD
	xor eax,ebx
	mov ebx,eax
	loop ll
	
	ret

Get_HAsh endp

Mcopy proc uses edi esi ecx otkuda:dword, kuda:dword, skolko:dword  

		mov	ecx,skolko
		mov edi,kuda
		mov	esi,otkuda
		rep movsb
		mov eax,edi
	ret

Mcopy endp

Unpack_app proc SOI:dword, ISH:dword
LOCAL t1: dword
LOCAL Start_buff :dword
LOCAL Start_Raw :dword
LOCAL First_sec_Off :dword
LOCAL Buff1 :dword
LOCAL VSrsrc :dword
LOCAL Copy0fPEheader :dword

		invoke ShowMess,addr unp0_msg
		;*** Allocating memory for unpacked file****
		invoke GlobalAlloc, GMEM_FIXED,SOI
		mov bufff,eax
		mov Start_buff,eax
		;*******************************************
		;**** Sciping size for pe header ***********
		mov edi,ISH
		assume edi:ptr IMAGE_SECTION_HEADER
		mov eax,[edi].PointerToRawData
		add bufff,eax
		mov Start_Raw,eax
		mov First_sec_Off,eax
		;*******************************************
		;***** Creating a copy of PE header ********
		invoke GlobalAlloc, GMEM_FIXED,eax
		mov Copy0fPEheader,eax 
		invoke Mcopy,pFile,Copy0fPEheader,First_sec_Off	;copyng pe header
		;*******************************************
		mov eax,AspLoader
		add eax, aspack.asptable		;going to aspack table
		mov	esi, eax
		mov edi,ISH
		mov eax,[esi]
		invoke ShowMess,addr unp1_msg
		int 3
		movsx ebx,sec2cut
		;sub Seccount,ebx
		.while Seccount!=ebx;1
			push ebx
			.if [edi].VirtualAddress !=eax
				
				;	push eax
				;	mov eax,RVA_res	
					mov ebx,[edi].VirtualAddress
					add ebx,[edi].Misc.VirtualSize
				;	pop eax
					
					.if ([edi].VirtualAddress < eax) && (ebx> eax)
;						int 3			
						pushad
						invoke ShowMess,addr unp2_msg
						;***** Prepearing to copy rsrc section***************
						push eax
						mov ecx,pFile
						add ecx,[edi].PointerToRawData	;ecx=pRSRC
						mov eax,[edi].Misc.VirtualSize	;eax=VSize of rsrc 
						;******* calculating file size of ather sections ****
						push ecx
						push edi
						mov ecx,Seccount
						dec ecx
kk:						add edi,sizeof IMAGE_SECTION_HEADER
						add eax,[edi].Misc.VirtualSize
						loop kk
						pop edi
						pop ecx
						;******************************************************
;						push edi						;saving curent(.rsrc) ISH
;						mov edi,Asp_ISH					;edi=ISH of rsrc
;						add eax,[edi].SizeOfRawData		;size=rscr+aspack
;						pop edi							;edi=ISH of rsrc
						push ecx						;saving ecx				
						invoke GlobalAlloc, GMEM_FIXED,eax
						pop ecx							;restoring ecx
						mov Buff1,eax												
						invoke Mcopy,ecx,Buff1,[edi].SizeOfRawData 
						mov ebx,Buff1							;eax=offset of Alocc Memory
						add ebx,[edi].Misc.VirtualSize			;ebx=Buff1+Vsize of rsrc
						mov VSrsrc,ebx							;VSrsrc=ebx				
						pop eax									;eax=Value of pack rsrc section (Withaut res tree)
						mov ebx,eax								;ebx=eax
						sub ebx,[edi].VirtualAddress			;ebx=offset from rsrc section
						add ebx,Buff1							;ebx=Buff1+ebx
						invoke RVAToOffset,Copy0fPEheader,eax						
						add eax,pFile
;						int 3						
						;*******Unpacking rsrc section propustiv res tree*********
;						push	ebx		;KUDA 
;						push	eax		;OTKUDA
;						call	unpack;102b
						invoke unpack,eax,ebx
;						add	esp, 8						
						;****** copy aspack section ******************
						push edi
						push ecx
						mov ecx,Seccount
						dec ecx
kk2:					add edi,sizeof IMAGE_SECTION_HEADER
						mov eax,pFile
						add eax,[edi].PointerToRawData
						invoke Mcopy,eax,VSrsrc,[edi].Misc.VirtualSize
						mov VSrsrc,eax
						loop kk2
						pop ecx
						pop edi
;						mov edi,Asp_ISH
;						assume edi:ptr IMAGE_SECTION_HEADER
;						mov eax,pFile
;						add eax,[edi].PointerToRawData
;						invoke Mcopy,eax,VSrsrc,[edi].SizeOfRawData
;						pop edi
						;**********************************************

						
						invoke Res_Rebuild,Buff1,[edi].VirtualAddress,[edi].Misc.VirtualSize,[edi].VirtualAddress,off_FileAlignment
						push eax
						invoke Mcopy,eax,bufff,edx
						mov bufff,eax
						pop eax
						;****[corecting pe header]******
						push edx
						push edx
						pop [edi].Misc.VirtualSize
						pop [edi].SizeOfRawData
						push Start_Raw
						pop [edi].PointerToRawData
						add Start_Raw,edx	
						;*******************************
						invoke GlobalFree,eax
						invoke GlobalFree,Buff1						
						;*********************************************
						popad
						add esi,8
					.else 
						mov eax,pFile
						add eax,[edi].PointerToRawData
						invoke Mcopy,eax,bufff,[edi].SizeOfRawData
						mov bufff,eax
						;****[corecting pe header]******
						mov eax,[edi].SizeOfRawData
						push Start_Raw
						pop [edi].PointerToRawData
						add Start_Raw,eax
						;*******************************
					.endif
			.else
				;int 3
				mov	eax, [esi+4]
				invoke GlobalAlloc, GMEM_FIXED,eax
				mov		t1, eax
				push	esi
				
				push 	eax
				invoke RVAToOffset,Copy0fPEheader,dword ptr [esi]
				mov ebx,eax
				add ebx,pFile
				pop eax
;				int 3
;				push	eax		;KUDA 
;				push	ebx		;OTKUDA
;				call	unpack;102b
				invoke unpack,ebx,eax
				
				invoke AlignSection, eax,[off_FileAlignment]
				;****[corecting pe header]******
				mov [edi].SizeOfRawData,eax
				push Start_Raw
				pop [edi].PointerToRawData
				add Start_Raw,eax
				;*******************************
;				add	esp, 8
				invoke Mcopy,t1,bufff,eax
				mov bufff,eax
				pop	esi
				invoke GlobalFree,t1
				
				add esi,8
				
			.endif
			add edi,sizeof IMAGE_SECTION_HEADER
			assume edi:ptr IMAGE_SECTION_HEADER
			dec Seccount
			mov eax,[esi]
		pop ebx				
		.endw
		invoke GlobalFree,Copy0fPEheader
		invoke ShowMess,addr unp3_msg
		;*** calculating file size ******************
		mov eax,bufff
		sub eax,Start_buff		
		mov FSize,eax
		mov eax,Start_buff
		mov bufff,eax
		;********************************************
		;***** corecting EOP *************************
		mov eax,pOEP
		mov edi,AspLoader
		add edi,aspack.entry
		mov edi,dword ptr [edi]
		XCHG dword ptr [eax],edi
		;********************************************
		;***** corecting Reloc *************************
		mov eax,off_Reloc_rva
		mov edi,AspLoader
		add edi,aspack.reloc
		mov edi,dword ptr [edi]
		XCHG dword ptr [eax],edi
		;********************************************
		;***** corecting IAT rva & size *************
		mov eax,off_IAT_rva	
		mov edi,AspLoader
		add edi,aspack.idata
		mov edi,dword ptr [edi]
		XCHG dword ptr [eax],edi
		;********************************************
		;***** corecting NumberOfSections  **********
		mov edi,off_sec_count
		movsx ecx,sec2cut
s2c:	dec word ptr [edi]
		loop s2c
		;********************************************
		;********** cleanin ISH of aspck ************
		;int 3
		mov eax,sizeof IMAGE_SECTION_HEADER
		imul sec2cut
		mov ecx,eax
		mov esi,Asp_ISH
LL:		mov byte ptr [esi], 00h
		inc esi
		loop LL
		;********************************************
		invoke Mcopy,pFile,bufff,First_sec_Off	;copyng pe header
		ret

Unpack_app endp
PE_Check proc uses edi
;/////////////////////////////////////////////
;//	RESULT:									//
;//		EAX=soi {SizeOfImage}				//
;//		EBX=ish {IMAGE_SECTION_HEADER}		//
;/////////////////////////////////////////////
local soi: dword
local ish: dword
LOCAL seh:SEH
	;*****[Seting SEH]***************************
	int 3
	assume fs:nothing
	LoadSEH
	;********************************************
	invoke ShowMess,addr Pecheck_msg
	mov edi, pFile
	assume edi:ptr IMAGE_DOS_HEADER
	.if [edi].e_magic==IMAGE_DOS_SIGNATURE
		add edi, [edi].e_lfanew
		assume edi:ptr IMAGE_NT_HEADERS
		
		.if [edi].Signature==IMAGE_NT_SIGNATURE
			invoke ShowMess,addr Pecheck_err_ok
			add edi,4d
			assume edi:ptr IMAGE_FILE_HEADER
			;*** Copyng & saving number of section ***
			movsx  eax, [edi].NumberOfSections
			mov Seccount,eax
			lea eax, [edi].NumberOfSections
			mov off_sec_count,eax
			;*****************************************
			add edi,sizeof IMAGE_FILE_HEADER
			assume edi:ptr IMAGE_OPTIONAL_HEADER32
			;**** saving the adress of entri point**** 
			lea eax,[edi].AddressOfEntryPoint
			mov pOEP,eax
			;*****************************************
			;******** saving SectionAlignment ********
			push [edi].FileAlignment
			pop off_FileAlignment
			;*****************************************
			;***** saving RVA & Size of resource *****
			mov eax,dword ptr [edi+70h]
			mov RVA_res,eax
			mov eax,dword ptr [edi+74h]
			mov Size_res,eax
			;*****************************************
			;*** saving offset of IAT RVA & Size ***
			lea eax,dword ptr [edi+68h]
			mov off_IAT_rva,eax
			lea eax,dword ptr [edi+6Ch]
			mov off_IAT_size,eax
			;***************************************
			;*** saving offset of Reloc RVA ***
			;int 3
			lea eax,dword ptr [edi+88h]
			mov off_Reloc_rva,eax
			;***************************************
			;********* saving offset to aspack loader & ish *****
			invoke RVAToOffset,pFile,[edi].AddressOfEntryPoint
			add eax,pFile
			mov AspLoader,eax
			push [edi].SizeOfImage
			pop soi
			add edi,sizeof IMAGE_OPTIONAL_HEADER32
			assume edi:ptr IMAGE_SECTION_HEADER
			mov ish,edi
			;****************************************************	
			;******* Checking in wich section is aspack ********* 
			mov ecx,Seccount
			mov eax,pOEP
			mov eax,dword ptr [eax]
			mov ebx,[edi].VirtualAddress
			add ebx,[edi].Misc.VirtualSize
			.while ecx!=0
				.BREAK .if ([edi].VirtualAddress <= eax) && (ebx> eax)
				add edi, sizeof IMAGE_SECTION_HEADER
				dec ecx			
				mov ebx,[edi].VirtualAddress
				add ebx,[edi].Misc.VirtualSize
			.endw
			.if ecx!=0
				mov Asp_ISH,edi
				mov sec2cut,cl
			;***********************************************
				;****** Checking aspack version *********************
				int 3
				call Get_HAsh
				lea ebx,Signatures
				assume ebx:ptr signature 
				.while ([ebx].chksum!=0) && (eax!=[ebx].chksum) 
					add ebx,sizeof signature
				.endw	
					.if eax==[ebx].chksum 
						push [ebx].asptable
						pop aspack.asptable
						push [ebx].entry
						pop aspack.entry
						push [ebx].idata
						pop aspack.idata
						push [ebx].version
						pop aspack.version
						push [ebx].reloc
						pop aspack.reloc
						invoke ShowMess,addr [ebx].aname								
						mov ValidPE, TRUE
						mov eax,soi
						mov ebx,ish
						
						
						;invoke Unpack_100b, soi,ish
					.else
						invoke  ShowMess,addr Aspack_err1_msg
						mov ValidPE, FALSE																	
					.endif
	
				;****************************************************
			.else
				invoke  ShowMess,addr Aspack_err1_msg
				mov ValidPE, FALSE						
			.endif
			;****************************************************		
		.else			
			mov ValidPE, FALSE
			invoke  ShowMess,addr Pecheck_err_msg
		.endif
	.else
		mov ValidPE,FALSE
		invoke  ShowMess,addr Pecheck_err_msg
	.endif		
FinalExit:
	;***[Removing SEH]*****
	push seh.PrevLink
	pop fs:[0]
	;**********************
	ret
PE_Check endp

Save_file proc uses eax hWin:dword;,SecSize :dword

;	mov dword ptr [buffer2],7273722EH	;coping .rsrc name to buffer
;	mov word ptr [buffer2+4],0063h
	mov ofn.lStructSize,SIZEOF ofn ;prepare ofn and save the file
	push hWin
	pop  ofn.hWndOwner
	push hInstance
	pop  ofn.hInstance
	mov  ofn.lpstrFilter, OFFSET FilterString
	mov  ofn.lpstrFile, OFFSET buffer2
	mov  ofn.nMaxFile,MAX_PATH
	mov  ofn.Flags, OFN_FILEMUSTEXIST or OFN_OVERWRITEPROMPT or\
                        OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
                        OFN_EXPLORER or OFN_HIDEREADONLY
	mov  ofn.lpstrTitle, OFFSET SaveTitle
							
	invoke GetSaveFileName, ADDR ofn
	.if eax!=TRUE
		invoke MessageBox, hWin, addr save_err, addr Err,MB_OK+MB_ICONERROR
		jmp ret0
	.endif
	invoke  CreateFile,addr buffer2, GENERIC_WRITE or GENERIC_READ,\
	                       FILE_SHARE_READ or FILE_SHARE_WRITE,NULL, \
        	                CREATE_ALWAYS	, FILE_ATTRIBUTE_NORMAL,NULL
	cmp eax,INVALID_HANDLE_VALUE
    jne @saveok        	                
		invoke MessageBox, hWin, addr save_err2, addr Err,MB_OK+MB_ICONERROR
		jmp ret0

@saveok:
;	int 3
	mov hFile2,eax
	invoke WriteFile,hFile2,bufff,FSize,addr bwrite,0
	invoke CloseHandle,hFile2
	invoke GlobalFree,bufff

ret0:	ret
Save_file endp
RVAToOffset PROC uses edi esi edx ecx pFileMap:DWORD,RVA:DWORD
	mov esi,pFileMap
	assume esi:ptr IMAGE_DOS_HEADER
	add esi,[esi].e_lfanew
	assume esi:ptr IMAGE_NT_HEADERS
	mov edi,RVA	; edi == RVA
	mov edx,esi
	add edx,sizeof IMAGE_NT_HEADERS
	mov cx,[esi].FileHeader.NumberOfSections
	movzx ecx,cx
	assume edx:ptr IMAGE_SECTION_HEADER
	.while ecx>0	; check all sections
		.if edi>=[edx].VirtualAddress
			mov eax,[edx].VirtualAddress
			add eax,[edx].SizeOfRawData
			.if edi<eax	; The address is in this section
				mov eax,[edx].VirtualAddress
				sub edi,eax	; edi == difference between the specified RVA and the section's RVA
				mov eax,[edx].PointerToRawData
				add eax,edi	; eax == file offset
				ret
			.endif
		.endif
		add edx,sizeof IMAGE_SECTION_HEADER
		dec ecx
	.endw
	assume edx:nothing
	assume esi:nothing
	mov eax,edi
	ret
RVAToOffset endp

ShowMess proc uses eax ecx edx Mes:dword
	invoke  SendDlgItemMessage, hWnd_main,IDC_LST1,LB_ADDSTRING,0,Mes
	invoke  SendDlgItemMessage, hWnd_main,IDC_LST1,LB_GETCOUNT,0,0
	dec eax
	invoke  SendDlgItemMessage, hWnd_main,IDC_LST1,LB_SETCURSEL,eax,0
	ret
ShowMess endp

end start

