
include windows.inc
include kernel32.inc
include user32.inc
include Comctl32.inc
include shell32.inc
include comdlg32.inc 
include mfmplayer.inc

includelib kernel32.lib
includelib user32.lib
Includelib comdlg32.lib 
includelib Comctl32.lib
includelib shell32.lib
includelib mfmplayer.lib

DlgProc			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
AboutProc		PROTO	:HWND,:UINT,:WPARAM,:LPARAM
OpenDialog 		proto :dword
RVAToOffset 	proto :dword,:dword
Unpack_app 		proto :dword,:dword
Mcopy 			proto :dword,:dword, :dword
Save_file 		proto :dword
ShowMess		proto :dword

SEH struct
	PrevLink dd ?		; the address of the previous seh structure
	CurrentHandler dd ?	; the address of the new exception handler
	SafeOffset 	dd ?	; The offset where it's safe to continue execution
	PrevEsp dd ?		; the old value in esp
	PrevEbp dd ?		; The old value in ebp
SEH ends

signature struc
chksum    	dd  ?                 ; checksum of first 200 bytes
aname     	db  17h dup (?)       ; name, must be 16 bytes long
version  	dd  ?                 ; aspack version, 102h=1.02, 1083h=1.08.03 etc.
asptable    dd  ?                 ; offset of objtbl of packed objects in .aspack
idata     	dd  ?                 ; offset of original import RVA in .aspack
reloc     	dd  ?                 ; offset of original fixups RVA in .aspack
entry     	dd  ?                 ; offset of original epoint RVA in .aspack
signature ends
.const

IDD_DIALOG1			equ 101
IDC_BTN1			equ 1001
IDC_BTN2			equ 1002
IDC_LST1			equ 1004
IDM_About			equ 10005
IDM_Load 			equ 10002
IDM_Exit 			equ 10003
IDD_About			equ 1000
IDM_MUSIC			equ 555
IDC_INFO			equ 12
IDC_Staff			equ 15
IDC_Thanks			equ 17
IDC_Copyright		equ 18
;#########################################################################
.data
aspack	signature <>
statClass db "STATIC",0
MAXSIZE equ 260
buffer db MAXSIZE dup(0) 
buffer2 db 'Unpacked.exe',0
;///////OFN structure///////
ofn   OPENFILENAME <>
FilterString db "PE files",0,"*.exe;*.dll",0,0	;for open file
OurTitle db "Choose Aspacked file to open",0
SaveTitle	db "Choose file to save",0
save_err		db "No file selected",0
save_err2		db "Can't save file",0
;//////////////////////////
Err db 'Error !',0
             
FileOpenMappingError db "Cannot open the file for memory mapping",0
FileMappingError db "Cannot map the file into memory",0
FileInValidPE db "This file is not a valid PE",0
;=============================================
Ready_msg			db 'Ready to work...',0
Pecheck_msg			db 'Checking file sructure ...',0
Pecheck_err_msg		db 'ERROR! This file is not a valid PE',0
Pecheck_err_ok		db 'It seems that file is OK!',0
mem_ok_msg			db 'Memory allocated OK!',0
mem_err_msg			db 'ERROR! Cannot allocate memory!',0
read_err			db 'ERROR! Cannot Read the file!',0
FileOpen_ok_msg 	db "File opened OK!",0
FileOpen_err_msg 	db "ERROR! Cannot open the file for reading",0
Aspack_err3_msg		db 'ERROR! This file is not packed with Aspack',0
Aspack_err1_msg		db 'ERROR! This file is packed with unsupported version of Aspack',0
unp0_msg 			db 'Allocating memory for unpacked file...',0
unp1_msg			db 'Unpacking file sections...',0
unp2_msg			db 'Reconstructing resource section...',0
unp3_msg			db 'Correcting PE header...',0
unp4_msg			db 'Saving unpacked file...',0
unp5_msg			db 'File unpacked successfully!',0
unp6_msg			db 'ERROR! Something is wrong'
unp7_msg			db 'ERROR! File saving faild' 
;=============================================
sInfo				db '          RASpack build 241',10,13
					db 'Coded in 100% Win32asm by seeQ',0
					
sStaff				db 'Coder. . . . . . . . . . . . . . . . . . . . . . . . . . . . . seeQ',10,13
					db 'GFX. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . seeQ',10,13
					db 'SFX. . . . . . . . . . . . . . . . . . . . .lesnik/Razor1911',0
					
sThanks				db 'BiDark - for helping with debugging in Masm32',10,13
					db 'bane/DTG - for unaspack source code ',10,13
					db 'Lise_Grim??? - for XM player',10,13
					db 'KISSFM and  DJ Sender - for music atmosphere',0
					
sCopyright			db "All rights reserved. Ukraine 2004",0 										

			; -ASPack-1.00b-
Signatures 	dd     0D8BAB327h					; checksum of first 200 bytes
          	db     'ASPack 1.00b Detected',0,0 	; name, must be 16 bytes long
          	dd     100h                   		; aspack version, 102h=1.02, 1083h=1.08.03 etc.
          	dd     355h                   		; offset of objtbl of packed objects in .aspack
          	dd     3DBh                   		; offset of original import RVA in .aspack
          	dd     349h ;???                   	; offset of original fixups RVA in .aspack 
          	dd     339h             			; offset of original epoint RVA in .aspack
          	; -ASPack-1.01b-
          	dd     0FC0DE158h
          	db     'ASPack 1.01b Detected',0,0 
          	dd     101h                   
          	dd     3EDh                   
          	dd     4D7h                   
          	dd     3F5h                   
          	dd     3D1h
          	; -ASPack-1.02b-
          	dd     5533F184h
          	db     'ASPack 1.02b Detected',0,0 
          	dd     102h                   
          	dd     401h                   
          	dd     4EBh                   
          	dd     3F5h                   
          	dd     3E5h
          ; -ASPack-1.08.01-                      
    	    dd     0F179033Ah
	        db     'ASPack 1.08.1 Detected',0  
          	dd     1081h                 
          	dd     57Ah                  
          	dd     781h                  
          	dd     56Ah                  
          	dd     55Ah                  
                   
			dd		0h
			
			
          

FileOpenOk db 00h




sss db 'GGGGGGGGGG',0
sss2 db '2222222222',0

.data?
hWnd_main			HANDLE ?;handle of main findow	
hIcon 				dd ?	;handle for icon
RVA_res				dd ?	;RVA of rsrc section
Size_res			dd ?	;Size of rsrc section
pOEP				dd ?	;offset to IMAGE_OPTIONAL_HEADER32.AddressOfEntryPoint
FSize				dd ?	;Size of unpacked file
bufff				dd ?	;pointer to unpacked file
AspLoader			dd ?	;offset to aspack loader (entry point)
Asp_ISH				dd ?	;offset to aspack IMAGE_SECTION_HEADER 
pFile				dd ?	;pointer to packed file in memory (after GlobalAlloc)
read_len			dd ?	;???? for ReadFile
EOP					dd ? 	
f_size				dd ?	;Size of packed file
hFile 				HANDLE ?	;Handle of packed file
hFile2 				HANDLE ?	;Handle of unpacked file
hMapFile 			HANDLE ?
off_FileAlignment	dd ?		;FileAlignment
off_SOI				dd ?		;SizeOfImage
ValidPE 			db ?
pMapping 			dd ?
hInstance			dd ?
Seccount			dd ?	;Number of section in packed file
IOH32				dd ?	
off_IAT_rva			dd ?	;offset to RVA of iat
off_IAT_size		dd ?	;offset to IAT size
off_Reloc_rva		dd ?	;offset to rva of reloc 
sec2cut				db ?	;section to cut
off_sec_count		dd ?

bwrite  dd  ?   ;number of written bytes
;#########################################################################

