
AlignSection proto :dword,:dword
Fillinfo proto :dword, :dword
Res_analiz proto :dword,:dword,:dword
Rebuild proto :dword, :dword,:dword,:dword,:dword
Res_Rebuild proto :dword,:dword,:dword,:dword,:dword
.data 

;Resoff dd ?		;address of resource section in memory
Corres db 512 dup(0)
Correscount dd 00h
RedirRes dd ?   ;size of redirected resource
CorrectRes dd ? ;size of normal resource
Namedres dd ?	;;size of named resource
LastRDE dd ?
xx dd 00h
BadRes db 00h


.code
;Rebuild proto secalign:dword, secrva:dword,Ressize:dword,Resoff:dword,Resrva:dword
Res_Rebuild proc uses edi ecx esi Resoff:dword,Resrva :dword, Ressize:dword, Secrva:dword, Secalign:dword
	
	invoke Res_analiz,Resoff,Resrva,Ressize
	invoke Rebuild,Secalign,Secrva,Ressize,Resoff,Resrva
ret

Res_Rebuild endp

Res_analiz proc uses edi eax edx esi Resoff:dword,Resrva :dword, Ressize:dword ;Secrva:dword, Secalign:dword
LOCAL irde,entrc:dword
		
		mov xx,00h
		mov Correscount,00h
		mov BadRes,00h
		mov CorrectRes,00h
		mov RedirRes,00h
	
	mov eax,Resoff
	;int 3
	mov LastRDE,0h;prepear for calculating last offset of the tree
	push 19334455h
n2:	assume eax:ptr IMAGE_RESOURCE_DIRECTORY
	movsx edi,word ptr [eax].NumberOfNamedEntries
	movsx esi,word ptr [eax].NumberOfIdEntries
	add esi,edi
	push esi

	add eax,sizeof IMAGE_RESOURCE_DIRECTORY
n3:	assume eax:ptr IMAGE_RESOURCE_DIRECTORY_ENTRY
	push eax
	mov edi,[eax].OffsetToData
	;***[Colecting size of named resourse]***
	pushad
	mov edi,[eax].Name1
	test edi,80000000h
	jz oo1
	and edi,0FFFFFFFh
	mov esi,Resoff
	add esi,edi
	assume esi:ptr IMAGE_RESOURCE_DIR_STRING_U
	movsx eax,[esi].Length1
	mov edx,02h
	mul edx
	add Namedres,eax
oo1:
	popad
	;****************************************
	test edi,80000000h
	jz n1
	and edi,0FFFFFFFh

	mov eax,Resoff
	add eax,edi
	jmp n2
n1:	mov eax,Resoff
	add eax,edi
	
;	nop
	.if LastRDE < edi
		mov LastRDE,edi
	.endif	
	;***[Showing res data entry offset]******************
;	.if xx==00h
;		pushad
;       	sub eax,Resoff
;	   	add eax,Resrva
;	  	invoke RVAToOffset,pMapping,eax
;		invoke wsprintf,addr buffer,addr template,eax
;    	invoke SetDlgItemText,hWnd,IDC_EDT3,ADDR buffer
;  	  	popad	
;	.endif
	;****************************************************
	;;;;;;;;;;
	invoke Fillinfo, Resrva, Ressize;eax
;	mov Konec,TRUE	
	pop irde
	pop entrc
	.while entrc ==1
		pop irde
		pop entrc
	.endw	
	dec entrc	
	push entrc
	mov eax,irde
	.if eax!=19334455h
		add eax,sizeof IMAGE_RESOURCE_DIRECTORY_ENTRY
		jmp n3
	.else
;		invoke wsprintf,addr buffer,addr template3,xx
;		invoke SetDlgItemText,hWnd,IDC_EDT4,ADDR buffer

		jmp en	
	.endif
en:	pop eax
	ret

Res_analiz endp

Check_Res proc Resitem:dword
	
	pushad
	xor ecx,ecx
	xor ebx, ebx
	.while ebx!= Correscount
		mov edx,Resitem
		movsx  eax,word ptr Corres[ecx]
		.if edx==eax
			mov BadRes,TRUE
			jmp hu
		.else	
			mov BadRes,FALSE
		.endif
		add ecx,2
		inc ebx
	.endw	
hu:popad	
	ret

Check_Res endp
Fillinfo proc uses eax edi esi edx Resrva :dword, Ressize:dword;IRDE:dword 
	LOCAL temp:word
	;int 3
	
;	push eax
	
	
;******[Analizing Resource]******
	pushad
	assume eax:ptr IMAGE_RESOURCE_DATA_ENTRY
	mov edi,Resrva
	mov esi,edi
	add edi,Ressize
	.if ([eax].OffsetToData >= esi) && ([eax].OffsetToData<= edi)
		;***[collecting size of normal resource]***
		mov edx,[eax].Size1
		add CorrectRes,edx
		;*********************************************
	.else
		;***[collecting size of rediracted resource]***
		mov edx,[eax].Size1
		add RedirRes,edx
		;*********************************************
		;***[Mark Rediracted resource for repaint]***
		pushad
		mov edx,xx
		lea esi,Corres
		mov eax,Correscount
		add eax,eax
		add esi,eax
		mov  word ptr [esi], dx
		inc Correscount
		popad
		;*******************************************
		
	.endif		
	popad
	inc xx
	ret
Fillinfo endp

Rebuild proc uses edi esi ecx secalign:dword, secrva:dword,Ressize:dword,Resoff:dword,Resrva:dword
LOCAL gMem,ngMem,num,newRva,SecSize,temp:dword
LOCAL irde,entrc:dword
;	int 3
	mov num,00h
;***[Calculating Section alignment]***	
;	mov edi,secalign
;	call _hexstr2dword
;	mov esi,eax
	mov esi,secalign
	mov eax,Ressize
	add eax,RedirRes
	invoke AlignSection, eax,esi
	mov SecSize,eax
;**************************************	
;***[Calculating Section RVA]***	
;	mov edi,secrva
;	call _hexstr2dword
;	mov secrva,eax
;**************************************	
	invoke GlobalAlloc,GMEM_FIXED,SecSize;eax
	mov gMem,eax
	
	mov esi,Resoff ;copy resource section to allocated memory
	mov edi,gMem
	mov ecx,Ressize
	rep movsb
	mov ngMem,edi

	push 19334455h
@n2:assume eax:ptr IMAGE_RESOURCE_DIRECTORY
	movsx edi,word ptr [eax].NumberOfNamedEntries
	movsx esi,word ptr [eax].NumberOfIdEntries
	add esi,edi
	push esi

	add eax,sizeof IMAGE_RESOURCE_DIRECTORY
@n3:assume eax:ptr IMAGE_RESOURCE_DIRECTORY_ENTRY
	push eax
	mov edi,[eax].OffsetToData
	
	test edi,80000000h
	jz @n1
	and edi,0FFFFFFFh

	mov eax,gMem
	add eax,edi
	jmp @n2
@n1:mov eax,Resoff
	add eax,edi
;****[R E B U I L D]************
;	int 3
	invoke Check_Res,num
	.if BadRes==TRUE
;		int 3
	;***[calculating new RVA for rediracted resource]***	
		mov temp,eax
		push edx
		mov edx,ngMem
		sub edx,gMem
		add edx,secrva
		mov newRva,edx
		pop edx
;		int 3
	;****************************************************
	;***[Coping redirected resources ]***	
		mov eax,temp
		pushad
		assume eax:ptr IMAGE_RESOURCE_DATA_ENTRY
		push eax
		;invoke RVAToOffset,pMapping,[eax].OffsetToData
		;mov esi,pMapping
		;add esi,eax
		;int 3
		mov esi,[eax].OffsetToData
		sub esi,Resrva
		mov eax,Resoff
		add esi,eax
		pop eax
		mov edi,ngMem
		mov ecx,[eax].Size1
		rep movsb
		mov ngMem,edi
		popad
	;**************************************	
	.else
	;***[calculating new RVA for not rediracted resource]***	
		pushad
		mov edx,gMem
		add edx,edi
		mov eax,edx
		assume eax:ptr IMAGE_RESOURCE_DATA_ENTRY
		mov edx,[eax].OffsetToData
		sub edx,Resrva
		mov edi,secrva
		add edx,edi
		mov newRva,edx
		popad			
	;********************************************************
	.endif	
	inc num
	;***[Writing new Rva ]*******
		push edx	
		mov edx,gMem
		add edx,edi
		mov eax,edx
		assume eax:ptr IMAGE_RESOURCE_DATA_ENTRY
		mov edx,newRva
		mov [eax].OffsetToData,edx
		pop edx
	;****************************

	pop irde
	pop entrc
	.while entrc ==1
		pop irde
		pop entrc
	.endw	
	dec entrc	
	push entrc
	mov eax,irde
	.if eax!=19334455h
		add eax,sizeof IMAGE_RESOURCE_DIRECTORY_ENTRY
		jmp @n3
	.else
		jmp @en	
	.endif
	
@en:	;int 3
;	invoke Save_file,hWin,SecSize
	mov eax,gMem
	mov edx,SecSize
	ret
Rebuild endp

_hexstr2dword proc
	push	ebx			; zapis ebx
	xor	eax,eax			; zerowanie eax

	push	8			; liczba powtorzen petli
	pop	ecx			; do rejestru ecx
_1:
	mov	dl,byte ptr [edi]	; znak do dl
	cmp	dl,0			; czy koniec
	je	_3
	sub	dl,30h			; zamien na hex
	cmp	dl,9
	jna	_2
	sub	dl,7
	cmp	dl,0Fh
	jna	_2
	sub	dl,20h
_2:
	add	al,dl			; zapisz do eax
	rol	eax,4
	inc	edi
	dec	ecx
	jne	_1

_3:
	ror	eax,4
	pop	ebx			; przywroc ebx
	ret

_hexstr2dword endp

AlignSection	proc uses edx ecx voff:DWORD,alignment:DWORD ;make win2k compatible.
	mov eax,voff
	mov ecx,alignment
	xor	edx, edx
	div	ecx           	;divide to section alignment
	or	edx, edx      	;if no remainder
	jz @F              	;it is aligned
	inc eax            	;aligned to next alignment value
@@:	    
	mul	ecx 			;multiply by alignment to align
	ret
AlignSection	endp